"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

RBProgramNodeVisitor subclass:#TProgramNodeVisitor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-AST'
!


!TProgramNodeVisitor methodsFor:'visiting'!

visitArgument: anRBVariableNode
    super visitArgument: anRBVariableNode.
    self visitNode: anRBVariableNode typeSpec

    "Created: / 25-08-2015 / 19:51:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TProgramNodeVisitor methodsFor:'visitor-double dispatching'!

acceptMethodNode: aMethodNode 
    super acceptMethodNode: aMethodNode.
    self visitNode: aMethodNode returnTypeSpec

    "Created: / 25-08-2015 / 19:53:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

acceptSimpleTypeNode: aTSimpleTypeNode

    "Created: / 21-08-2015 / 22:20:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2015 / 19:54:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

acceptTypeSpecNode: aTTypeSpecNode
    self visitNode: aTTypeSpecNode type.

    "Created: / 21-08-2015 / 22:18:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-08-2015 / 19:54:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

acceptUnionTypeNode: aTUnionTypeNode
    aTUnionTypeNode types do:[:type | self visitNode: type ]

    "Created: / 21-08-2015 / 22:21:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (format): / 25-08-2015 / 19:54:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TProgramNodeVisitor class methodsFor:'documentation'!

version
    ^ 'Path: jv/tea/compiler/TProgramNodeVisitor.st, Version: 1.0, User: jv, Time: 2015-08-25T19:55:02.763+01'
!

version_HG
    ^ 'Path: jv/tea/compiler/TProgramNodeVisitor.st, Version: 1.0, User: jv, Time: 2015-08-25T19:55:02.763+01'
! !

